#include "GUI.hpp"


/** GUI_run
 *  The GUI_run-function starts all functions needed for the GUI.
 */

auto GUI_run(int argc, char **argv) -> int {
    vkvm::initialize(0);
    int window_height, window_width;
    window_height = vkvm::getHeight();
    window_width = vkvm::getWidth();
    char *resolusion = get_resolusion(window_height, window_width);
    std::cout << resolusion << std::endl;
    GUI_Window *window = new GUI_Window(window_width, window_height + 30, "example");
    Statusbar *status[5];
    //Dummy-Values TBD
    window->begin();
    Image *image = new Image(0, 30, window_width, window_height);

    status[0] = new Statusbar(0, 0, 300, 30, resolusion);
    status[1] = new Statusbar(300, 0, 170, 30, "Event:");
    status[2] = new Statusbar(470, 0, 200, 30, "Mouse Position:");
    vkvm::registerEvent(vkvm::EventType::Redraw, [image](){
        image->redraw();
    });
    Fl::repeat_timeout(0.5, refresh_image, image);
    window->end();
    window->show(argc, argv);
    return Fl::run();
}

char *get_resolusion(int window_height, int window_width) {
    char *resolusion = new char[25];
    std::string str_temp;
    strcpy(resolusion, "Resolution Height:");
    str_temp = std::to_string(window_height);
    strcat(resolusion, str_temp.c_str());
    strcat(resolusion, " Width:");
    str_temp = std::to_string(window_width);
    strcat(resolusion, str_temp.c_str());
    return resolusion;
}

void get_new_image(void *pointer) {
    ((Image *) pointer)->getPixels();
    Fl::repeat_timeout(0.5, refresh_image, pointer);
}

void refresh_image(void *pointer) {
    ((Image *) pointer)->redraw();
    Fl::repeat_timeout(0.5, get_new_image, pointer);
}


